#include <math.h>
#include <stdlib.h>
#include "nrutil.c"


float *y, *x; 

float c;


void euler_step (float x, 
	 			 float y, 
				 float h, 
				 float (*f) (float, float), 
				 float *ynext)
{
	(*ynext) = y + h * ((*f)(x, y));
}


void euler_drv (float x0, 
				float x1, 
				int xstep,
				float y0,
				float (*f) (float, float))
{
	float h, ynext;
	int i;

	h = (x1-x0)/xstep;

	x[1] = x0;
	y[1] = y0;

	for (i=1; i<=xstep; i++)
	{
		euler_step (x[i], 
					y[i], 
					h, 
					f, 
					&ynext);

		x[i+1] = x[i]+h;
		y[i+1] = ynext;
	}
}


float f_exp (float x, float y)
{
	return (c*y);
}


void main (int argc, char *argv[])
{

	int i, xstep;
	float x0, x1, y0;


	x0 = 0.0;
	x1 = 1.0;
	xstep = 1024;
	y0 = 1.0;
	c = -1.0;


	for (i=1; i<argc; i++ ){
		
		switch(i){
	    case 1: 
			x0 = atof(argv[1]); 
			break;
		case 2:
			x1 = atof(argv[2]); 
			break;
		case 3:
			xstep = atoi(argv[3]); 
			break;
		case 4:
			y0 = atof(argv[4]);
			break;
		case 5:
			c = atof(argv[5]);
			break;
		} 
	}

	x = vector (1,xstep+1);
	y = vector (1,xstep+1);


	euler_drv (	x0, 
				x1, 
				xstep,
				y0,
				f_exp);

	for (i=1;i<=xstep+1;i++)
		printf("%f\t%f\n", x[i], y[i]);
}
