(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[      4428,        141]
NotebookOptionsPosition[      3845,        119]
NotebookOutlinePosition[      4291,        137]
CellTagsIndexPosition[      4248,        134]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{
  "SetDirectory", "[", "\"\<d:\\Attila\\Comphysx\\F620E\\Class6\\Debug\>\"", 
   "]"}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{"<<", 
  StyleBox[
   RowBox[{"Graphics", 
    StyleBox["`", "Text"]}]]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"egzy", "[", "x_", "]"}], "=", 
  RowBox[{"y0", "*", 
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{"c", " ", 
     RowBox[{"(", 
      RowBox[{"x", "-", "x0"}], ")"}]}]]}]}]], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"x0", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"x1", "=", "10"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xstep", "=", "100"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"y0", "=", "2"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "=", 
   RowBox[{"-", "1"}]}], ";"}]}], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"eulerdata", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
     RowBox[{"\"\<!euler.exe \>\"", "<>", 
      RowBox[{"ToString", "[", "x0", "]"}], "<>", "\"\< \>\"", "<>", 
      RowBox[{"ToString", "[", "x1", "]"}], "<>", "\"\< \>\"", "<>", 
      RowBox[{"ToString", "[", "xstep", "]"}], "<>", "\"\< \>\"", "<>", 
      RowBox[{"ToString", "[", "y0", "]"}], "<>", "\"\< \>\"", "<>", 
      RowBox[{"ToString", "[", "c", "]"}]}], ",", "\"\<Table\>\""}], "]"}]}], 
  ";"}]], "Input"],

Cell[BoxData[
 RowBox[{"Show", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"ListPlot", "[", 
    RowBox[{"eulerdata", ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", "Red", "}"}]}], ",", 
     RowBox[{"DisplayFunction", "\[Rule]", "Identity"}]}], 
    "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"egzy", "[", "x", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "x0", ",", "x1"}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", "Blue", "}"}]}], ",", 
     RowBox[{"DisplayFunction", "\[Rule]", "Identity"}]}], 
    "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
   RowBox[{"DisplayFunction", "\[Rule]", "$DisplayFunction"}]}], 
  "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.447575834640625*^9, 3.447575835296875*^9}}],

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Abs", "[", 
       RowBox[{
        RowBox[{"eulerdata", "[", 
         RowBox[{"[", 
          RowBox[{"n", ",", "2"}], "]"}], "]"}], "-", " ", 
        RowBox[{"egzy", "[", 
         RowBox[{"eulerdata", "[", 
          RowBox[{"[", 
           RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}], "]"}], "/", 
      RowBox[{"egzy", "[", 
       RowBox[{"eulerdata", "[", 
        RowBox[{"[", 
         RowBox[{"n", ",", "1"}], "]"}], "]"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"n", ",", "1", ",", 
       RowBox[{"Length", "[", "eulerdata", "]"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"Joined", "\[Rule]", "True"}]}], "\[IndentingNewLine]", 
  "]"}]], "Input",
 CellChangeTimes->{{3.4475758471875*^9, 3.447575847890625*^9}}]
},
WindowSize->{1034, 889},
WindowMargins->{{8, Automatic}, {Automatic, 0}},
DockedCells->FEPrivate`FrontEndResource[
 "FEExpressions", "CompatibilityToolbar"],
Magnification->2,
FrontEndVersion->"7.0 for Microsoft Windows (32-bit) (November 10, 2008)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 139, 4, 57, "Input"],
Cell[687, 26, 107, 4, 57, "Input"],
Cell[797, 32, 223, 7, 60, "Input"],
Cell[1023, 41, 370, 11, 194, "Input"],
Cell[1396, 54, 516, 11, 160, "Input"],
Cell[1915, 67, 1020, 23, 330, "Input"],
Cell[2938, 92, 903, 25, 194, "Input"]
}
]
*)

(* End of internal cache information *)

